package cours
{

	import starling.utils.Color;
	import starling.text.BitmapFont;
	import starling.textures.Texture;
	import flash.display.Bitmap;
	import starling.events.Event;
	import flash.utils.getTimer;
	import starling.text.TextField;
	import starling.display.Sprite;

	/**
	 * @author Administrateur
	 */
	public class FPS extends Sprite
	{
		private var oTextFPS : TextField;

		private static var nLastTime : uint = getTimer();
		private static var ticks : uint = 0;
		private static var text : String = "--.- FPS";
		
		[Embed(source = "../bin/fonts/fps-font_0.png")]
		private static const oBitmapChars : Class;
		
		[Embed(source="../bin/fonts/fps-font.fnt", mimeType="application/octet-stream")]
		private static const oFontXML : Class;

		public function FPS()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			// création de l'image bitmap embed (fichier spritesheet)
			var bitmap : Bitmap = new oBitmapChars();

			// création d'une textuer à partir de l'image bitmap
			var texture : Texture = Texture.fromBitmap(bitmap);

			// création du fichier xml qui contient la position de chaque lettre / chiffre
			var xml : XML = XML(new oFontXML());

			// enregistre la police bitmap pour la rendre disponible dans les TextField
			TextField.registerBitmapFont(new BitmapFont(texture, xml));

			// création de l'objet TextField
			oTextFPS = new TextField(133, 33, "... FPS", "Chicken Butt", 12);
			
			oTextFPS.fontSize = BitmapFont.NATIVE_SIZE;
			
			// bordure
			//oTextFPS.border = true;

			// utilisation de la couleur de la texture (texte plus précis et clair)
			oTextFPS.color = Color.BLACK;

			// affiche du texte
			addChild(oTextFPS);

			// écouteur sur chaque image
			stage.addEventListener(Event.ENTER_FRAME, onFrame);
		}
		
		
		/**
		 * Mise à jour de la valeur FPS
		 * à chaque image.
		 * 
		 */
		public function onFrame(e : Event) : void
		{
			ticks++;
			var nNowTimer : uint = getTimer();
			var delta : uint = nNowTimer - nLastTime;
			if (delta >= 1000)
			{
				var fps : Number = ticks / delta * 1000;
				text = fps.toFixed(1) + " FPS";
				ticks = 0;
				nLastTime = nNowTimer;
			}
			oTextFPS.text = text;
		}
	}
}
